Java关于在catch中抛出一个异常给外围函数却捕获不到的问题

先给出一串代码:
package javaException;

public class TestException {
public TestException(){
}

boolean testEx()throws Exception{
    boolean ret=true;
    try{
        ret=testEx1();
    }
    catch(Exception e){
        System.out.println("testEx, catch exception");
        ret=false;
        throw e;
    }
    finally{
        System.out.println("testEx, finally:return value:"+ret);
        return ret;
    }
}

boolean testEx1()throws Exception{
    boolean ret=true;
    try{
        ret=testEx2();
        if(!ret){
            return false;
        }
        System.out.println("testEx1, at the end of try");
        return ret;
    }
    catch(Exception e){
        System.out.println("testEx1, catch exception");
        ret=false;
        throw e;
    }
    finally{
        System.out.println("testEx1, finally:return value:"+ret);
        return ret;
    }
}

boolean testEx2()throws Exception{
    boolean ret=true;
    try{
        int b=12;
        int c;
        for(int i=2;i>=-2;i--){
            c=b/i;
            System.out.println("i="+i);
        }
        return true;
    }
    catch(Exception e){
        System.out.println("testEx2, catch exception");
        ret=false;
        throw e;
    }
    finally {
        System.out.println("testEx2, finally:return value="+ret);
        return ret;
    }
}

public static void main(String[] args) {
    // TODO Auto-generated method stub
    TestException testException1=new TestException();
    try{
        testException1.testEx();
    }
    catch(Exception e){
        e.printStackTrace();
    }
}

}
对于函数testEx2()中catch块中抛出的异常,testEx1()函数却捕获不到,这是为什么呢?
我想过一种可能:testEx1()中将testEx2()的返回值赋值给ret,即 ret=testEx2(),而testEx2()中抛出的异常在这个过程中被过滤掉了。因为如果我直接把testEx2()放在testEx1()中,而不是通过ret=testEx2()的方式,那么这个异常是能够被捕获的。
求证各位大佬!!!

2个回答

YaoDeBiAn
YaoDeBiAn 里面讲的是final的问题,但是其实该问题并没有什么意义,final有无并没有什么影响吧
接近 3 年之前 回复

为什么方法后面已经抛出异常,方法里面还要try()catch() 新手,表示没明白

Canhumm
SS_Sky 哦哦,好吧,受教了
接近 3 年之前 回复
YaoDeBiAn
YaoDeBiAn 这是多层嵌套
接近 3 年之前 回复
Csdn user default icon
上传中...
上传图片
插入图片
抄袭、复制答案,以达到刷声望分或其他目的的行为,在CSDN问答是严格禁止的,一经发现立刻封号。是时候展现真正的技术了!
立即提问